/*
 * Copyright (C) 2006 Taybin Rutkin <taybin@taybin.com>
 * Copyright (C) 2007-2015 Paul Davis <paul@linuxaudiosystems.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

#ifndef __pbd_whitespace_h__
#define __pbd_whitespace_h__

#include <string>

#include "pbd/libpbd_visibility.h"

namespace PBD {

// returns the empty string if the entire string is whitespace
// so check length after calling.
	LIBPBD_API extern void strip_whitespace_edges (std::string& str);
	LIBPBD_API extern void remove_extra_whitespace (std::string const & in, std::string & out);
} // namespace PBD

#endif // __pbd_whitespace_h__
